#ifndef Py_LONGOBJECT_H
#define Py_LONGOBJECT_H
#ifdef __cplusplus
extern "C" {
#endif

/***********************************************************
Copyright 1991-1995 by Stichting Mathematisch Centrum, Amsterdam,
The Netherlands.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the names of Stichting Mathematisch
Centrum or CWI or Corporation for National Research Initiatives or
CNRI not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission.

While CWI is the initial source for this software, a modified version
is made available by the Corporation for National Research Initiatives
(CNRI) at the Internet address ftp://ftp.python.org.

STICHTING MATHEMATISCH CENTRUM AND CNRI DISCLAIM ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL STICHTING MATHEMATISCH
CENTRUM OR CNRI BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

******************************************************************/

/* Long (arbitrary precision) integer object interface */

typedef struct _longobject PyLongObject; /* Revealed in longintrepr.h */

extern DL_IMPORT(PyTypeObject) PyLong_Type;

#define PyLong_Check(op) ((op)->ob_type == &PyLong_Type)

extern DL_IMPORT(PyObject *) PyLong_FromLong Py_PROTO((long)) SEG_LONGOBJECT_H;
extern DL_IMPORT(PyObject *) PyLong_FromUnsignedLong Py_PROTO((unsigned long)) SEG_LONGOBJECT_H;
extern DL_IMPORT(PyObject *) PyLong_FromDouble Py_PROTO((double)) SEG_LONGOBJECT_H;
extern DL_IMPORT(long) PyLong_AsLong Py_PROTO((PyObject *)) SEG_LONGOBJECT_H;
extern DL_IMPORT(unsigned long) PyLong_AsUnsignedLong Py_PROTO((PyObject *)) SEG_LONGOBJECT_H;
extern DL_IMPORT(double) PyLong_AsDouble Py_PROTO((PyObject *)) SEG_LONGOBJECT_H;
extern DL_IMPORT(PyObject *) PyLong_FromVoidPtr Py_PROTO((void *)) SEG_LONGOBJECT_H;
extern DL_IMPORT(void *) PyLong_AsVoidPtr Py_PROTO((PyObject *)) SEG_LONGOBJECT_H;

#ifdef HAVE_LONG_LONG

#ifdef HAVE_LIMITS_H
#include <limits.h>
#endif

/* Hopefully this is portable... */
#ifndef LONG_MAX
#define LONG_MAX 2147483647L
#endif
#ifndef ULONG_MAX
#define ULONG_MAX 4294967295U
#endif
#ifndef LONGLONG_MAX
#define LONGLONG_MAX 9223372036854775807LL
#endif
#ifndef ULONGLONG_MAX
#define ULONGLONG_MAX 0xffffffffffffffffULL
#endif
#ifndef LONG_LONG
#define LONG_LONG long long
#endif

extern DL_IMPORT(PyObject *) PyLong_FromLongLong Py_PROTO((LONG_LONG)) SEG_LONGOBJECT_H;
extern DL_IMPORT(PyObject *) PyLong_FromUnsignedLongLong Py_PROTO((unsigned LONG_LONG)) SEG_LONGOBJECT_H;
extern DL_IMPORT(LONG_LONG) PyLong_AsLongLong Py_PROTO((PyObject *)) SEG_LONGOBJECT_H;
extern DL_IMPORT(unsigned LONG_LONG) PyLong_AsUnsignedLongLong Py_PROTO((PyObject *)) SEG_LONGOBJECT_H;
#endif /* HAVE_LONG_LONG */

DL_IMPORT(PyObject *) PyLong_FromString Py_PROTO((char *, char **, int)) SEG_LONGOBJECT_H;

#ifdef __cplusplus
}
#endif
#endif /* !Py_LONGOBJECT_H */
